function HiScoreInit()
   HiScore = {}
   for i= 0,9 do
      HiScore[i] = {}
      HiScore[i].Score = (10-i) * 400
      HiScore[i].Name = "- DRWHO-198 -"
   end
   HiScore[0].Name = "-------------"
   HiScore[1].Name = "-           -"
   HiScore[2].Name = "-  SCENERY  -"
   HiScore[3].Name = "-           -"
   HiScore[4].Name = "-  B E T A  -"
   HiScore[5].Name = "-           -"
   HiScore[6].Name = "-  2 0 0 8  -"
   HiScore[7].Name = "-           -"
   HiScore[8].Name = "-------------"
   HiScore[9].Name = "- DRWHO-198 -"
   HiScoreHilight = -1
end

function HiScoreChk()
   if Score > HiScore[9].Score then
      -- local PlrName = System.startOSK("Name","Enter Name")
      local PlrName = HiScoreInputName()
      if PlrName == "" then
         RNDName = {}
         RNDName[0] = "John Doe"
         RNDName[1] = "2 Lazy 2 Type"
         RNDName[2] = "Mr. Anonimous"
         RNDName[3] = "Whats My Name?"
         RNDName[4] = "Writers Block"
         RNDName[5] = "Unknown Human"
         RNDName[6] = "R.I.P. Stranger"
         RNDName[7] = "I'm way too shy"
         RNDName[8] = "No time to type"
         RNDName[9] = "Dr. Nobody"
         RNDName[10] = "2sexy4thisgame"
         RNDName[11] = "Is this safe?"
         RNDName[12] = "born 2B a loser"
         RNDName[13] = "Rumpelstiltskin"
         PlrName = RNDName[ math.random(0,13) ]
      end
      if PlrName then HiScoreSubmit(Score,PlrName) end
   end
end

function HiScoreSubmit(NewScore,NewName)
   local tmpScore = 0
   local tmpName = ""
   
   for i= 0,9 do
      if NewScore > HiScore[i].Score then
         if HiScoreHilight == -1 then
            HiScoreHilight = i
         end
         
         tmpScore = HiScore[i].Score
         tmpName = HiScore[i].Name
         
         HiScore[i].Score = NewScore
         HiScore[i].Name = NewName
         
         NewScore = tmpScore
         NewName = tmpName         
      end
   end
end

function HiScoreList()
   --[[
   screen:flip()
   screen:clear()
   Music.stop()
   ]]--
   
   PrintLine = "HI-SCORE"
   FontDraw(1,screen ,(480 -FontTextsize(1,PrintLine))/2 , 50,PrintLine)
   
   for i= 0,9 do
      PrintLine = (i+1) .. ")"
      FontDraw(2,screen,100,80+(i*12),PrintLine)

      PrintLine = HiScore[i].Score
      FontDraw(2,screen,125,80+(i*12),PrintLine)

      PrintLine = string.upper(HiScore[i].Name)
      FontDraw(2,screen,250,80+(i*12),PrintLine)
   end
   
   screen:flip()
   screen.waitVblankStart(3)
   
   WaitForCross2()
end

function HiScoreAnimated( Delay )

   ImgHiScore = Image.createEmpty(250,272)
   ImgHiScore.clear(Color.new(0,0,0,0))
   
   PrintLine = "HI-SCORE"
   FontDraw(1, ImgHiScore ,10+(180 -FontTextsize(1,PrintLine))/2 , 50,PrintLine)
   
   if HiScoreHilight ~= -1 then
      -- ImgHiScore:fillRect(231,89+(HiScoreHilight*12), 104 + string.len(HiScore[HiScoreHilight].Name)*6, 9, Color.new(155,3,205))
      ImgHiScore:fillRect(1,89+(HiScoreHilight*12), 104 + 15*6, 9, Color.new(155,3,205))
      HiScoreHilight = -1
   end
   
   for i= 0,9 do
      
      PrintLine = (i+1) .. ")"
      FontDraw(2,ImgHiScore,10,90+(i*12),PrintLine)

      PrintLine = HiScore[i].Score
      FontDraw(2,ImgHiScore,35,90+(i*12),PrintLine)

      PrintLine = string.upper(string.sub(HiScore[i].Name,1,15))
      FontDraw(2,ImgHiScore,95,90+(i*12),PrintLine)
   end   
   
   PrintLine = "WITH MUSIC BY JOGIER LILJEDAHL"
   FontDraw(2,ImgHiScore ,45 ,260,PrintLine)

   if Delay then
      ExitAt = os.clock() + Delay
   end
   
   keydown = 5
   
   while true do
      pad = Controls.read()
      
   
      FxScroll = FxScroll +2
      if FxScroll >= 480 then
         FxScroll = FxScroll - 480         
      end
      
      screen:blit(0, 0, ImgTitleClouds,FxScroll,0,480-FxScroll,272, false)
      screen:blit(480-FxScroll, 0, ImgTitleClouds,0,0,FxScroll,272, false)

      for i= 0,5 do
         local ShiftX = FxStars[i].pos
         local ShiftY = math.floor(FxStars[i].pos /480 *272)
         
         screen:blit(FxStars[i].x+ShiftX, FxStars[i].y - ShiftY, ImgTitleFx,FxStars[i].anim * 69,0,69,69, true)
         FxStars[i].pos = FxStars[i].pos - FxStars[i].speed
         
         FxStars[i].anim = FxStars[i].anim +1
         if FxStars[i].anim == 7 then FxStars[i].anim = 0 end
         
         if FxStars[i].pos <= -240 then
            FxStars[i].pos = 240
         end
      end
            
      screen:blit(0, 0, ImgTitle, true)
      screen:blit(230, 0, ImgHiScore, true)

      screen:flip()
            
      if pad:cross() and (keydown ~= 5)  then
         break
      elseif (pad:cross() == false) and (keydown == 5) then
         keydown = 0
      end

      
      if Delay then
         if ExitAt <= os.clock() then break end
      end
      
      screen.waitVblankStart(2)
   end
   
   ExitAt = nil
   
end

function HiScoreInputName(InitName)
 
   ImgVKeyb = Image.createEmpty(200,150)
   ImgVKeyb.clear(Color.new(0,0,0,0))
   
   local HiScoreCharSet = "ABCDEFGHIJKLMNOPQRSTUVWXYZ-?!.0123456789"
   local CSelX = 0
   local CSelY = 0
   
   for i=0, 3 do
      for j=0, 9 do
         local PrintLine = string.sub(HiScoreCharSet,(i*10+1)+j,(i*10+1)+j)
         FontDraw(2,ImgVKeyb,j*20 +2,i*17 +2,PrintLine)
      end
   end
   
   local PrintLine = "DEL"
   FontDraw(2,ImgVKeyb,0 +2,4*17 +2,PrintLine)

   local PrintLine = "SPACE"
   FontDraw(2,ImgVKeyb,78 +2,4*17 +2,PrintLine)

   local PrintLine = "END"
   FontDraw(2,ImgVKeyb,168 +2,4*17 +2,PrintLine)
   
   -- PrintLine = "HI-SCORE"
   -- FontDraw(1,ImgHiScore ,200+ (280 -FontTextsize(1,PrintLine))/2 , 50,PrintLine)   
   
   if Delay then
      ExitAt = os.clock() + Delay
   end
   
   local InputName = ""   
   
   if InitName ~= nil then InputName = InitName end
   
   RDown = 0
   LDown = 0
   UDown = 0
   DDown = 0
   
   CrossDown = 1
   CircleDown = 0
   TriangleDown = 0
   SquareDown = 0

   while true do
         
      pad = Controls.read()

      FxScroll = FxScroll +2
      if FxScroll >= 480 then
         FxScroll = FxScroll - 480         
      end
      
      screen:blit(0, 0, ImgTitleClouds,FxScroll,0,480-FxScroll,272, false)
      screen:blit(480-FxScroll, 0, ImgTitleClouds,0,0,FxScroll,272, false)

      for i= 0,5 do
         local ShiftX = FxStars[i].pos
         local ShiftY = math.floor(FxStars[i].pos /480 *272)
         
         screen:blit(FxStars[i].x+ShiftX, FxStars[i].y - ShiftY, ImgTitleFx,FxStars[i].anim * 69,0,69,69, true)
         FxStars[i].pos = FxStars[i].pos - FxStars[i].speed
         
         FxStars[i].anim = FxStars[i].anim +1
         if FxStars[i].anim == 7 then FxStars[i].anim = 0 end
         
         if FxStars[i].pos <= -240 then
            FxStars[i].pos = 240
         end
      end

      screen:blit(0, 0, ImgTitle, true)
      PrintLine = "HI-SCORE"
      FontDraw(1,screen ,200+ (260 -FontTextsize(1,PrintLine))/2 , 50,PrintLine)
      screen:blit(240, 130, ImgVKeyb,0 ,0 , 200, 130, true)
      
      screen:drawLine(240,98,435,98,Color.new(0,0,0))
      screen:drawLine(240,108,435,108,Color.new(0,0,0))
      
      if pad:right() then
         if RDown < 2 then
            CSelX = CSelX +1
            if CSelY ~= 4 then
               if CSelX >= 10 then
                  CSelX = CSelX -10
               end
            else
               if CSelX >= 3 then
                  CSelX = CSelX -3
               end 
            end
            if RDown == 0 then 
               RDown = 9
            else
               RDown = 3
            end
         else
            RDown = RDown -1
         end
      elseif RDown ~= 0 then
         RDown = 0
      end
      
      if pad:left() then
         if LDown < 2 then
            CSelX = CSelX -1
            if CSelX < 0 then
               if CSelY ~= 4 then
                  CSelX = CSelX +10
               else
                  CSelX = CSelX +3
               end 
            end
            if LDown == 0 then 
               LDown = 9
            else
               LDown = 3
            end
         else
            LDown = LDown -1
         end
      elseif LDown ~= 0 then
         LDown = 0
      end
      
      if pad:up() then
         if UDown < 2 then
            if CSelY == 4 then
               if CSelX == 1 then CSelX = 4 end
               if CSelX == 2 then CSelX = 9 end               
            end
            
            CSelY = CSelY -1
            if CSelY < 0 then CSelY = CSelY +5 end
            if CSelY == 4 then
               if CSelX < 3 then
                  CSelX = 0
               elseif CSelX > 6 then
                  CSelX = 2
               else
                  CSelX = 1
               end               
            end

            if UDown == 0 then 
               UDown = 9
            else
               UDown = 3
            end
         else
            UDown = UDown -1
         end
      elseif UDown ~= 0 then
         UDown = 0
      end
      
      if pad:down() then
         if DDown < 2 then
            if CSelY == 4 then
               if CSelX == 1 then CSelX = 4 end
               if CSelX == 2 then CSelX = 9 end               
            end
            CSelY = CSelY +1
            if CSelY == 4 then
               if CSelX < 3 then
                  CSelX = 0
               elseif CSelX > 6 then
                  CSelX = 2
               else
                  CSelX = 1
               end               
            end

            if CSelY >= 5 then CSelY = CSelY -5 end
            if DDown == 0 then 
               DDown = 9
            else
               DDown = 3
            end
         else
            DDown = DDown -1
         end
      elseif DDown ~= 0 then
         DDown = 0
      end
      
      if pad:triangle() then
         if TriangleDown == 0 then
            TriangleDown = 1
            break           
         end
      elseif TriangleDown ~= 0 then
         TriangleDown = 0
      end
      
      if pad:cross() then
         if CrossDown == 0 then
            if CSelY ~= 4 then
               if string.len(InputName) < 15 then
                  InputName = InputName .. string.sub(HiScoreCharSet, CSelY*10+CSelX+1, CSelY*10+CSelX+1)
               end
            else
               if CSelX == 0 then
                  InputName = string.sub(InputName,1,string.len(InputName)-1)
               elseif CSelX == 1 then
                  if string.len(InputName) < 15 then
                     InputName = InputName .. " "
                  end
               else
                  break
               end
            end
            CrossDown = 1
         end
      elseif CrossDown ~= 0 then
         CrossDown = 0
      end
   
      if pad:circle() then
         if CircleDown == 0 then
            
            CircleDown = 1
         end
      elseif CircleDown ~= 0 then
         CircleDown = 0
      end
      
      if pad:square() then
         if SquareDown == 0 then
            
            SquareDown = 1
         end
      elseif SquareDown ~= 0 then
         SquareDown = 0
      end
      
      if CSelY ~= 4 then
         local CSelXpos = 240+ CSelX *20 
         local CSelYpos = 130+  CSelY *17
         
         screen:drawLine(CSelXpos ,CSelYpos , CSelXpos +10,CSelYpos ,Color.new(255,0,0))
         screen:drawLine(CSelXpos ,CSelYpos , CSelXpos ,CSelYpos +10,Color.new(255,0,0))
         screen:drawLine(CSelXpos +10,CSelYpos +10, CSelXpos +10,CSelYpos ,Color.new(255,0,0))
         screen:drawLine(CSelXpos +10,CSelYpos +10, CSelXpos ,CSelYpos +10,Color.new(255,0,0))
      else
         local CSelXpos = 0 
         local CSelSize = 0
         
         if CSelX == 0 then
            CSelXpos = 240+0
            CSelSize = 22
         elseif CSelX == 1 then
            CSelXpos = 240+78
            CSelSize = 34
         else
            CSelXpos = 240+168 
            CSelSize = 22
         end
         local CSelYpos = 130+  CSelY *17
         
         screen:drawLine(CSelXpos ,CSelYpos , CSelXpos +CSelSize,CSelYpos ,Color.new(255,0,0))
         screen:drawLine(CSelXpos ,CSelYpos , CSelXpos ,CSelYpos +10,Color.new(255,0,0))
         screen:drawLine(CSelXpos +CSelSize,CSelYpos +10, CSelXpos +CSelSize,CSelYpos ,Color.new(255,0,0))
         screen:drawLine(CSelXpos +CSelSize,CSelYpos +10, CSelXpos ,CSelYpos +10,Color.new(255,0,0))
      end

      local InputPadding = (195-(string.len(InputName)*6+1))/2
      
      screen:fillRect(240 +InputPadding +string.len(InputName) *6 ,100 +4, 9, 3, Color.new(0,0,0))
      screen:drawLine(240 +InputPadding +string.len(InputName) *6 +1,100 +5, 240 +InputPadding + (string.len(InputName)+1) *6 +1,100 +5,Color.new(255,0,0))
      FontDraw(2,screen,240 +InputPadding ,100,InputName)
      
      
      screen:flip()      
      
      if Delay then
         if ExitAt <= os.clock() then break end
      end
      
      screen.waitVblankStart(2)
   end
   
   ExitAt = nil
   ImgVKeyb = nil
   
   return InputName   
end

function HiScoreSave(FileName)
   FileHighScore = io.output(FileName)
   for i= 0,9 do
      FileHighScore:write(HiScore[i].Score .. string.char(10))
      FileHighScore:write(HiScore[i].Name .. string.char(10))
   end
   FileHighScore:close()
end

function HiScoreLoad(FileName)
   FileHighScore = io.input(FileName)
   for i= 0,9 do
      HiScore[i].Score = tonumber(FileHighScore:read())
      HiScore[i].Name = FileHighScore:read()
   end      
   FileHighScore:close()
end

HiScoreInit()

