function PauseMenu()
   
   local MnuOps = {}
   
   MnuOps[1] = {}
   MnuOps[1].Name = "CONTINUE"
   MnuOps[1].Function = VoidFunc

   MnuOps[2] = {}
   MnuOps[2].Name = "OPTIONS"
   MnuOps[2].Function = Options   
   
   MnuOps[3] = {}
   MnuOps[3].Name = "END GAME"
   MnuOps[3].Function = EndGame   
  
   
   local MnuCur = 1
   local NrOps = 3

   local MnuTop = (260-(NrOps*10))/2
   
   local InMenu = true
   local RedrawMenu = true
   
   local PadDown = false
   local PadUp = false
   local PadX = false
   local PadO = false
   
   local ImgMnuPause = Image.createEmpty(180,150)

   for i = 1,NrOps do   
      PrintLine = MnuOps[i].Name
      FontDraw(1,ImgMnuPause ,(180 -(FontTextsize(1,PrintLine)))/2 ,(i-1)*25,PrintLine)
   end
   
   while true do
      pad = Controls.read()
      if not(pad:cross()) and not(pad:circle()) then break end
      screen.waitVblankStart()
   end

   local ImgScrDump = Image.createEmpty(480,272)
   ImgScrDump:blit(0,0,screen,0,0,480,272,false)

   while InMenu do
      if RedrawMenu then
         screen:blit(0,0,ImgScrDump,false)
         screen:fillRect(150,100-2+(MnuCur-1)*25,180,22,Color.new(155,3,205))
         screen:blit(150,100,ImgMnuPause,true)

         screen:flip()
         RedrawMenu = false
      end
      
      pad = Controls.read()
      
      if pad:up() then
         if PadUp == false then
            PadUp = true
            MnuCur = MnuCur -1
            if MnuCur == 0 then MnuCur = NrOps end
            RedrawMenu = true
         end
      else
         PadUp = false
      end
      
      if pad:down() then
         if PadDown == false then
            PadDown = true
            MnuCur = MnuCur +1
         if MnuCur == NrOps +1 then MnuCur = 1 end
            RedrawMenu = true
         end
      else
         PadDown = false            
      end
      
      if pad:circle() then
         if PadO == false then
            PadO = true
            InMenu = false
         end
      else
         PadO = false
      end
      
      if pad:cross() then
         if PadO == false then
            PadX = true
            InMenu = false
            
            MnuOps[MnuCur].Function()
         end
      else
         PadX = false
      end
      
      screen.waitVblankStart(3)      
   end
   
   while true do
      pad = Controls.read()
      if not(pad:cross()) and not(pad:circle()) then break end
      screen.waitVblankStart()
   end
end

function EndGame()
   Lives = -1
   GameRunning = false
end

function VoidFunc()
end
