ImgTitle = Image.load("images/title_a.png")
ImgTitleClouds = Image.load("images/clouds.png")
ImgTitleFx = Image.load("images/title_fx2.png")


   FxStars = {}
   FxScroll = 0

   for i= 0,5 do
      FxStars[i] = {}
      -- local RndPos = math.random(0,479)
      local RndPos = math.floor(479/6 * (i+.5))      
      
      FxStars[i].x = RndPos
      FxStars[i].y = math.floor(RndPos/480*272)
      
      FxStars[i].pos =  math.random(0,510) -240
      FxStars[i].speed =  3 +math.random(0,5)/10
      
      FxStars[i].anim = math.random(0,6)
   end   


function Title( Delay )
   if Delay then
      ExitAt = os.clock() + Delay
   end
   
   local Cursor = 0
   local keydown = 0
   
   keydown = 5
   
   local ImgMnutxt = Image.createEmpty(240,272)
   
   PrintLine = "NEW GAME"
   FontDraw(1,ImgMnutxt ,(80 -(FontTextsize(1,PrintLine))/2) ,70,PrintLine)
   
   PrintLine = "HI-SCORE"
   FontDraw(1,ImgMnutxt ,(80 -(FontTextsize(1,PrintLine))/2) ,95,PrintLine)
   
   PrintLine = "OPTIONS"
   FontDraw(1,ImgMnutxt ,(80 -(FontTextsize(1,PrintLine))/2) ,120,PrintLine)
   
   PrintLine = "CREDITS"
   FontDraw(1,ImgMnutxt ,(80 -(FontTextsize(1,PrintLine))/2) ,145,PrintLine)
   
   PrintLine = "QUIT"
   FontDraw(1,ImgMnutxt ,(80 -(FontTextsize(1,PrintLine))/2) ,180,PrintLine)
   
   PrintLine = "WITH MUSIC BY JOGIER LILJEDAHL"
   FontDraw(2,ImgMnutxt ,35 ,260,PrintLine)
   
   while true do
      pad = Controls.read()
      
   
      FxScroll = FxScroll +2
      if FxScroll >= 480 then
         FxScroll = FxScroll - 480         
      end
      
      screen:blit(0, 0, ImgTitleClouds,FxScroll,0,480-FxScroll,272, false)
      screen:blit(480-FxScroll, 0, ImgTitleClouds,0,0,FxScroll,272, false)

      for i= 0,5 do
         local ShiftX = FxStars[i].pos
         local ShiftY = math.floor(FxStars[i].pos /480 *272)
         
         screen:blit(FxStars[i].x+ShiftX, FxStars[i].y - ShiftY, ImgTitleFx,FxStars[i].anim * 69,0,69,69, true)
         FxStars[i].pos = FxStars[i].pos - FxStars[i].speed
         
         FxStars[i].anim = FxStars[i].anim +1
         if FxStars[i].anim == 7 then FxStars[i].anim = 0 end
         
         if FxStars[i].pos <= -240 then
            FxStars[i].pos = 240
         end
      end
            
      screen:blit(0, 0, ImgTitle, true)

      if Cursor ~= 4 then
         screen:fillRect(320 - 70, 68 +Cursor *25, 140, 22, Color.new(155,3,205))
      else
         screen:fillRect(320 - 70, 68 +10 +Cursor *25, 140, 22, Color.new(155,3,205))
      end

      screen:blit(240, 0, ImgMnutxt, true)


      --[[
      PrintLine = "NEW GAME"
      FontDraw(1,screen ,(320 -(FontTextsize(1,PrintLine))/2) ,80,PrintLine)

      PrintLine = "HI-SCORE"
      FontDraw(1,screen ,(320 -(FontTextsize(1,PrintLine))/2) ,105,PrintLine)
      
      PrintLine = "OPTIONS"
      FontDraw(1,screen ,(320 -(FontTextsize(1,PrintLine))/2) ,130,PrintLine)

      PrintLine = "QUIT"
      FontDraw(1,screen ,(320 -(FontTextsize(1,PrintLine))/2) ,165,PrintLine)
      ]]--
      
      screen:flip()

      if pad:down() and (keydown ~= 2) then
         Cursor = Cursor +1
         if Cursor >= 5 then Cursor = 0 end                  
         keydown = 2
      elseif (pad:down() == false) and (keydown == 2) then
         keydown = 0
      end

      if pad:up() and (keydown ~= 4) then
         Cursor = Cursor -1
         if Cursor < 0 then Cursor = 4 end                  
         keydown = 4
      elseif (pad:up() == false) and (keydown == 4) then
         keydown = 0
      end

      if pad:cross() and (keydown ~= 5)  then
         keydown = 5
         if Cursor == 0 then
            break
         elseif Cursor == 1 then
            HiScoreAnimated()
            
         elseif Cursor == 2 then
            Options()
            
         elseif Cursor == 3 then
            DoCredits2()
            
         elseif Cursor == 4 then
            System.Quit()
         end
      elseif (pad:cross() == false) and (keydown == 5) then
         keydown = 0
      end
      
      if Delay then
         if ExitAt <= os.clock() then break end
      end
      
      screen.waitVblankStart(2)
   end
   
   ExitAt = nil
   
   while true do
      pad = Controls.read()
      if not(pad:cross()) then break end
      screen.waitVblankStart()
   end
end


function Options()

   if Delay then
      ExitAt = os.clock() + Delay
   end
   
   local Cursor = 0
   local keydown = 0
   
   keydown = 5

   local ImgMnutxt = Image.createEmpty(250,272)
   
   PrintLine = "MUSIC VOL"
   FontDraw(1,ImgMnutxt ,0 ,65,PrintLine)
   
   PrintLine = "SFX VOL"
   FontDraw(1,ImgMnutxt ,0 ,90,PrintLine)
   
   PrintLine = "BATTERY ALERT"
   FontDraw(1,ImgMnutxt ,0 ,115,PrintLine)
   
   PrintLine = "RESET HI-SCORE"
   FontDraw(1,ImgMnutxt ,0 ,140,PrintLine)

   PrintLine = "LEVEL EDITOR"
   FontDraw(1,ImgMnutxt ,0 ,165,PrintLine)

   PrintLine = "DONE"
   FontDraw(1,ImgMnutxt ,0 ,200,PrintLine)
   
   PrintLine = "WITH MUSIC BY JOGIER LILJEDAHL"
   FontDraw(2,ImgMnutxt ,45 ,260,PrintLine)
   
   while true do
      pad = Controls.read()
      
   
      FxScroll = FxScroll +2
      if FxScroll >= 480 then
         FxScroll = FxScroll - 480         
      end
      
      screen:blit(0, 0, ImgTitleClouds,FxScroll,0,480-FxScroll,272, false)
      screen:blit(480-FxScroll, 0, ImgTitleClouds,0,0,FxScroll,272, false)

      for i= 0,5 do
         local ShiftX = FxStars[i].pos
         local ShiftY = math.floor(FxStars[i].pos /480 *272)
         
         screen:blit(FxStars[i].x+ShiftX, FxStars[i].y - ShiftY, ImgTitleFx,FxStars[i].anim * 69,0,69,69, true)
         FxStars[i].pos = FxStars[i].pos - FxStars[i].speed
         
         FxStars[i].anim = FxStars[i].anim +1
         if FxStars[i].anim == 7 then FxStars[i].anim = 0 end
         
         if FxStars[i].pos <= -240 then
            FxStars[i].pos = 240
         end
      end
            
      screen:blit(0, 0, ImgTitle, true)
      
      if Cursor ~= 5 then
         screen:fillRect(220, 63 +Cursor *25, 240, 22, Color.new(155,3,205))
      else
         screen:fillRect(220, 63 +10 +Cursor *25, 240, 22, Color.new(155,3,205))
      end

      screen:blit(230, 0, ImgMnutxt, true)
      
      PrintLine = tostring(MusicVol)
      FontDraw(1,screen ,450 - FontTextsize(1,PrintLine) ,65,PrintLine)

      PrintLine = tostring(SFXVol)
      FontDraw(1,screen ,450 - FontTextsize(1,PrintLine) ,90,PrintLine)

      if BatteryAlert then
         PrintLine = "+"
      else
         PrintLine = "-"
      end
      FontDraw(1,screen ,450 - FontTextsize(1,PrintLine) ,115,PrintLine)

      --[[
      PrintLine = "MUSIC VOL"
      FontDraw(1,screen ,230 ,80,PrintLine)
      PrintLine = tostring(MusicVol)
      FontDraw(1,screen ,450 - FontTextsize(1,PrintLine) ,80,PrintLine)
      
      PrintLine = "SFX VOL"
      FontDraw(1,screen ,230 ,105,PrintLine)
      PrintLine = tostring(SFXVol)
      FontDraw(1,screen ,450 - FontTextsize(1,PrintLine) ,105,PrintLine)
      
      PrintLine = "BATTERY ALERT"
      FontDraw(1,screen ,230 ,130,PrintLine)
      if BatteryAlert then
         PrintLine = "+"
      else
         PrintLine = "-"
      end
      FontDraw(1,screen ,450 - FontTextsize(1,PrintLine) ,130,PrintLine)
      
      PrintLine = "RESET HI-SCORE"
      FontDraw(1,screen ,230 ,155,PrintLine)
      
      PrintLine = "DONE"
      FontDraw(1,screen ,230 ,190,PrintLine)
      ]]--
      
      screen:flip()

      if pad:down() and (keydown ~= 2) then
         Cursor = Cursor +1
         if Cursor >= 6 then Cursor = 0 end                  
         keydown = 2
      elseif (pad:down() == false) and (keydown == 2) then
         keydown = 0
      end
      
      if pad:up() and (keydown ~= 4) then
         Cursor = Cursor -1
         if Cursor < 0 then Cursor = 5 end                  
         keydown = 4
      elseif (pad:up() == false) and (keydown == 4) then
         keydown = 0
      end
      
      if pad:right() and (keydown ~= 1) then
         if Cursor == 0 then
            if MusicVol < 5 then
               MusicVol = MusicVol +1
               if Music.playing() then
                  Music.volume(math.floor(128/5*MusicVol))               
               end
               SndBounce:play()
            end
         elseif Cursor == 1 then
            if SFXVol < 5 then
               SFXVol = SFXVol +1
               SoundSystem.SFXVolume(math.floor(128/5*SFXVol))
               SndBounce:play()
            end
         elseif Cursor == 2 then
            if BatteryAlert then
               BatteryAlert = false
            else
               BatteryAlert = true
            end
            SndBounce:play()
         end
         keydown = 1
      elseif (pad:right() == false) and (keydown == 1) then
         keydown = 0
      end
      
      if pad:left() and (keydown ~= 3) then
         if Cursor == 0 then
            if MusicVol > 0 then
               MusicVol = MusicVol -1
               if Music.playing() then
                  Music.volume(math.floor(128/5*MusicVol))
               end
               SndBounce:play()
            end
         elseif Cursor == 1 then
            if SFXVol > 0 then
               SFXVol = SFXVol -1
               SoundSystem.SFXVolume(math.floor(128/5*SFXVol))
               SndBounce:play()
            end
         elseif Cursor == 2 then
            if BatteryAlert then
               BatteryAlert = false
            else
               BatteryAlert = true
            end
            SndBounce:play()
         end
         keydown = 3
      elseif (pad:left() == false) and (keydown == 3) then
         keydown = 0
      end
      
      if pad:cross() and (keydown ~= 5)  then
         keydown = 5
         if Cursor == 0 then
            --
         elseif Cursor == 1 then
            --
         elseif Cursor == 2 then
            if BatteryAlert then
               BatteryAlert = false
            else
               BatteryAlert = true
            end
            SndBounce:play()

         elseif Cursor == 3 then
               System.message("Do you wish to reset the hiscore table?",1)
               if System.buttonPressed(0) == 1 then
                  HiScoreInit()
                  HiScoreSave("data/HiScore.dat")
               end
         elseif Cursor == 4 then
            SettingsSave()
            dofile("LevelEdit.lua")
            System.Quit()
         elseif Cursor == 5 then
            SettingsSave()
            break
         end
      elseif (pad:cross() == false) and (keydown == 5) then
         keydown = 0
      end

      if pad:circle() and (keydown ~= 6)  then
         break
      elseif (pad:circle() == false) and (keydown == 6) then
         keydown = 0
      end
      
      if Delay then
         if ExitAt <= os.clock() then break end
      end
      
      screen.waitVblankStart(2)
   end
   
   ExitAt = nil
   
   while true do
      pad = Controls.read()
      if not(pad:cross()) then break end
      screen.waitVblankStart()
   end
end

